function inj_params = compute_waveform_parameters (params, ...
						   anteproc_cachefile_name, ...
						   anteproc_matfiles_name)

% The function computes the SNR, hrss and duration of an injection
% Inputs:
% - params: structure filled from the params_inj_X_Y.txt files
% - anteproc_cachefile_name: filename (full path) of the anteproc
% cache file
% - anteproc_matfiles_name: file name of the processed matfiles
%
% Outputs:
% - inj_params: structure will all injection information
%
% Contact: Marie Anne Bizouard (mabizoua@lal.in2p3.fr) 2015

dic = classes.waveforms.dictionary;

% Add default params values
params.fixAntennaFactors=0;
params.bestAntennaFactors=0;

% Fix the injection start and end times
t_start=params.pass.stamp.startGPS;

% end GSP time is fixed to t_start + size of the map (500s)
params.startGPS=t_start;
params.endGPS=t_start+params.mapsize;

% Get IFOs PSDs
% Needs to define some anteproc parameters to access to the anteproc
% matfiles that is generated by BKG dag (not foreseen to be used for injections)

% Do a jobfile time-shift?
params.anteproc.jobFileTimeShift = false;

% Define timeshift applied to IFO streams
params.anteproc.timeShift1=0;
params.anteproc.timeShift2=params.largeShiftTime2;

% No stitching of the data. No check to be done
params.anteproc.bkndstudy = false;

% Load anteproc cachefile
params.anteproc.useCache=true;
params.anteproc.matfilesName=anteproc_matfiles_name;
params.anteproc.inmats1=' ';
params.anteproc.inmats2=' ';
params.anteproc.cacheFile=anteproc_cachefile_name;

[matlist,params] = find_anteproc_mats(params);

% load_anteproc_mats requires params.fmin instead of params.flow
params.fmin=params.flow;
params.fmax=params.fhigh;

[map1, params1] = load_anteproc_mats(matlist,params,1);
[map2, params2] = load_anteproc_mats(matlist,params,2);

% Get PSDs
ext=find(map1.segstarttime(:)>t_start);
psd1=map1.P(:,ext(1));

ext=find(map2.segstarttime(:)>t_start);
psd2=map2.P(:,ext(1));

flow=params.flow;
fhigh=params.fhigh;
deltaF=params.deltaF;

freq=flow:deltaF:fhigh;
psd1=[transpose(freq) psd1];
psd2=[transpose(freq) psd2];

% Get the simulation iLIGO
psd=load('PSDs/LIGOsrdPSD_40Hz.txt');

% Get waveform amplitude at the source and build the strain amplitude at each IFO
stamp_inj.file=params.pass.stamp.file;

% Get hp and hx of the injection
[hp, hx]=load_injection(params, stamp_inj, params.sampleRate);

params.pass.stamp.hp=hp;
params.pass.stamp.hx=hx;

% Build the strain signal in both IFOs, for the source location and
% start time.
% h1 and h2 are scaled by sqrt(alpha) but not hx and hp
params= getPointSourceData_IM(params, t_start, params.sampleRate);

h1=params.pass.stamp.h1;
h2=params.pass.stamp.h2;

% Compute SNRs with iLIGO simulated PSD
SNR1=matchedfilter(h1,h1,psd,params.sampleRate,flow,fhigh);
SNR2=matchedfilter(h2,h2,psd,params.sampleRate,flow,fhigh);

% Compute SNRs with real data PSDs
SNR1s=matchedfilter(h1,h1,psd1,params.sampleRate,flow,fhigh);
SNR2s=matchedfilter(h2,h2,psd2,params.sampleRate,flow,fhigh);

% Get waveform duration
output=strsplit(params.pass.stamp.file,'/');
waveform_path=output{1};
waveform_name=output{2};

wheader = dic.headers(waveform_name);

% Compute hrss
hrss=get_hrss(hp,hx,params.sampleRate,params.pass.stamp.alpha);

% Save parameters
inj_params.ra=params.pass.stamp.ra;
inj_params.decl=params.pass.stamp.decl;
inj_params.startGPS=params.pass.stamp.startGPS;
inj_params.name=params.pass.stamp.file;
inj_params.inj_type=params.pass.stamp.inj_type;
inj_params.iota=params.pass.stamp.iota;
inj_params.psi=params.pass.stamp.psi;
inj_params.F1=params.pass.stamp.F1;
inj_params.F2=params.pass.stamp.F2;
inj_params.SNR1=SNR1;
inj_params.SNR2=SNR2;
inj_params.SNR1s=SNR1s;
inj_params.SNR2s=SNR2s;
inj_params.hrss=hrss;
inj_params.duration=wheader.duration;
inj_params.alpha=params.pass.stamp.alpha;

%figure(1)
%plot(hp(1:1000))
%hold on
%plot(hx(1:1000),'r');

%plot(params.pass.stamp.h1(1:1000),'g')
%plot(params.pass.stamp.h2(1:1000),'k')
%hold off
%legend('hp', 'hx', 'h1', 'h2')

